import random as rd
import tkinter
import time
from PIL import Image, ImageTk

score_total = 0
manche = 1

def reset():
    global actifs, inactifs, joues, nombre_42, des_actifs, images_des_actifs
    print("Manche n°%d"%manche)
    actifs = 0
    inactifs = 3
    joues = 0
    nombre_42 = 0

    des_actifs = [2, 2, 2, 2, 2, 2, 2]
    images_des_actifs = []
    
    afficher_etat()

    des_actifs = []
    joues = 7

def indice_de_en_fonction_de_position(x, y):
    x -= 25
    y -= 100
    res = x // 50
    if res < 0 or res > 4:
        return -1
    if y < 0 or y > 100:
        return -1
    if y > 50:
        res += 5
    return res

def lancer_des_restants():
    global actifs, joues, score_total
    if actifs != 0:
        print("On ne peut pas relancer s'il reste des dés actifs !")
        return
    actifs = joues
    joues = 0
    des_actifs[:] = []
    for _ in range(actifs):
        des_actifs.append(rd.randint(0, 5))
    afficher_etat()
    test = test_fin_tour()
    if test == 0:
        print("Score pour cette manche : %d"%(nombre_42*(nombre_42+1)//2))
        score_total += nombre_42*(nombre_42+1)//2
        gestion_fin_manche()
    elif test < 0:
        print("Fin de la manche")
        gestion_fin_manche()

def encaisser():
    global score_total
    if actifs != 0:
        print("On ne peut pas encaisser les points s'il reste des dés actifs !")
    score_manche = nombre_42*(nombre_42+1)//2
    print("Score pour cette manche : %d"%score_manche)
    score_total += score_manche
    gestion_fin_manche()

def test_fin_tour():
    global nombre_42, actifs
    if des_actifs == [4]:
        print("Il ne reste qu'un vaisseau, le tour est perdu")
        return -1
    for i in [1, 2, 4, 5]:
        if i in des_actifs:
            return 1
    if 3 in des_actifs:
        print("Il reste au moins un dragon, le tour est perdu")
        return -1
    else:
        nombre_42 += actifs
        actifs = 0
        return 0

def afficher_etat():
    c00.create_image(175, 125, image=imgaff00)
    c01.create_image(175, 125, image=imgaff01)
    c10.create_image(175, 125, image=imgaff10)
    c11.create_image(175, 125, image=imgaff11)
    i = 0
    images_des_actifs[:] = []
    for de in des_actifs:
        images_des_actifs.append(c00.create_image(50+50*(i%5), 125+50*(i//5), image=images[de]))
        c00.tag_bind(images_des_actifs[i], '<Button-1>', actions[de])
        i += 1
    c00.update()
    for i in range(nombre_42):
        c01.create_image(50+50*(i%5), 125+50*(i//5), image=images[0])
    c01.update()
    for i in range(inactifs):
        c10.create_image(50+50*(i%5), 125+50*(i//5), image=images[6])
    c10.update()
    for i in range(joues):
        c11.create_image(50+50*(i%5), 125+50*(i//5), image=images[6])
    c11.update()

def rien(self):
    pass

def relancer(self):
    global actifs, joues
    action(1)
    if actifs == 0:
        print("Plus de dé à utiliser")
        verification()
        return
    for indice in range(len(images_des_actifs)):
        c00.tag_bind(images_des_actifs[indice], '<Button-1>', rien)
    def choix_de(evt):
        x = evt.x
        y = evt.y
        indice = indice_de_en_fonction_de_position(x, y)
        if 0 <= indice < actifs:
            nouveau_de = rd.randint(0, 5)
            des_actifs[indice] = nouveau_de
            time.sleep(.5)
            images_des_actifs[indice] = c00.create_image(50+50*(indice%5), 125+50*(indice//5), image=images[nouveau_de])
            c00.tag_bind(images_des_actifs[indice], '<Button-1>', actions[nouveau_de])
            c00.unbind("<Button-3>")
            afficher_etat()
            verification()
        else:
            print("Clic hors zone")
    c00.bind("<Button-3>", choix_de)

def permuter(self):
    global actifs, joues
    action(2)
    if actifs == 0:
        print("Plus de dé à utiliser")
        verification()
        return
    for indice in range(len(images_des_actifs)):
        c00.tag_bind(images_des_actifs[indice], '<Button-1>', rien)
    def choix_de(evt):
        x = evt.x
        y = evt.y
        indice = indice_de_en_fonction_de_position(x, y)
        if 0 <= indice < actifs:
            nouveau_de = 5-des_actifs[indice]
            des_actifs[indice] = nouveau_de
            images_des_actifs[indice] = c00.create_image(50+50*(indice%5), 125+50*(indice//5), image=images[nouveau_de])
            c00.tag_bind(images_des_actifs[indice], '<Button-1>', actions[nouveau_de])
            c00.unbind("<Button-3>")
            afficher_etat()
            verification()
        else:
            print("Clic hors zone")
    c00.bind("<Button-3>", choix_de)
    
def detruire(self):
    global inactifs, actifs, joues
    action(4)
    for indice in range(len(images_des_actifs)):
        c00.tag_bind(images_des_actifs[indice], '<Button-1>', rien)
    def choix_de(evt):
        global actifs, inactifs
        x = evt.x
        y = evt.y
        indice = indice_de_en_fonction_de_position(x, y)
        if 0 <= indice < actifs:
            actifs -= 1
            inactifs += 1
            des_actifs.pop(indice)
            images_des_actifs.pop(indice)
            c00.unbind("<Button-3>")
            afficher_etat()
            verification()
        else:
            print("Clic hors zone")
    c00.bind("<Button-3>", choix_de)

def recuperer(self):
    global inactifs, actifs, joues
    action(5)
    if inactifs > 0:
        actifs += 1
        inactifs -= 1
        nouveau_de = rd.randint(0, 5)
        des_actifs.append(nouveau_de)
        time.sleep(.5)
        images_des_actifs.append(c00.create_image(50+50*((actifs-1)%5), 125+50*((actifs-1)//5), image=images[nouveau_de]))
        c00.tag_bind(images_des_actifs[actifs-1], '<Button-1>', actions[nouveau_de])
    afficher_etat()
    verification()

actions = [rien, relancer, permuter, rien, detruire, recuperer]

def action(de):
    global actifs, joues
    if de != 0 and de != 3:
        joues += 1
        actifs -= 1
        indice = des_actifs.index(de)
        des_actifs.pop(indice)
        images_des_actifs.pop(indice)
        afficher_etat()

def verification():
    global score_total, manche
    test = test_fin_tour()
    if test == 0:
        if joues > 0:
            print("Décidez si vous voulez relancer tous les dés ou encaisser les points.")
    elif test < 0:
        print("Fin de la manche")
        gestion_fin_manche()

def gestion_fin_manche():
    global manche
    if manche == 5:
        print("Score final : %d"%score_total)
        Fen.destroy()
    else:
        manche += 1
        reset()


Fen=tkinter.Tk()
Fen.geometry("800x600")
Fen.config(bg="white")
c00=tkinter.Canvas(Fen, bg="green", width=350, height=250)
c00.place(x=25, y=25)
c01=tkinter.Canvas(Fen, bg="green", width=350, height=250)
c01.place(x=375, y=25)
c10=tkinter.Canvas(Fen, bg="green", width=350, height=250)
c10.place(x=25, y=275)
c11=tkinter.Canvas(Fen, bg="green", width=350, height=250)
c11.place(x=375, y=275)
img00 = Image.open("zone00.png")
imgaff00 = ImageTk.PhotoImage(img00)
img01 = Image.open("zone01.png")
imgaff01 = ImageTk.PhotoImage(img01)
img10 = Image.open("zone10.png")
imgaff10 = ImageTk.PhotoImage(img10)
img11 = Image.open("zone11.png")
imgaff11 = ImageTk.PhotoImage(img11)

imgd = []
imgd.append(Image.open("42.png"))
imgd.append(Image.open("meeple.png"))
imgd.append(Image.open("superhero.png"))
imgd.append(Image.open("dragon.png"))
imgd.append(Image.open("spaceship.png"))
imgd.append(Image.open("1up.png"))

images = [ImageTk.PhotoImage(imgdi) for imgdi in imgd] + [ImageTk.PhotoImage(Image.open("de.png"))]

bouton = tkinter.Button(Fen, text="Lancer les dés (restants)", command=lancer_des_restants)
bouton.place(x=200, y=550)

bouton2 = tkinter.Button(Fen, text="Encaisser les points", command=encaisser)
bouton2.place(x=400, y=550)

reset()

Fen.mainloop()
